Bug 487985 - The autofs cache lookup performs poorly for large maps.
The autofs cache lookup performs poorly for large maps.
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: autofs (Show other bugs)
5.3
All Linux
low Severity medium
: rc
: ---
Assigned To: Ian Kent
BaseOS QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-03-01 20:59 EST by Ian Kent
Modified: 2010-03-14 17:28 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Previously, the additive hashing algorithm used by autofs to generate hash values would result in a clustering of values that favoured a small range of hash indexes and led to reduced performance in large maps. Autofs now uses a "one-at-a-time" hash function which gives a better distribution of hash values in large hash tables. Use of the "one-at-a-time" hash function safeguards lookup performance as maps increase to 8,000 entries and beyond.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 07:59:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Ian Kent 2009-03-01 20:59:41 EST
Description of problem:

For large maps (6000+ entries) we need to decrease hash chain size
to improve performance, which we should be able to do by increasing
the hash table size. Unfortunately, the additive hashing algorithm
used by autofs results in a clustering of hash values around the
average hash chain size. It is biased toward a small range of hash
indexes which becomes more of a problem as the hash table size
increases.

Testing shows that the "One-at-a-time" hash function gives a much
better distribution of hash indexes as table size increases. This
change has been implemented upstream and should also be done in
RHEL-5 autofs.
Comment 5 Ruediger Landmann 2009-08-31 00:58:48 EDT
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
Previously, the additive hashing algorithm used by autofs to generate hash values would result in a clustering of values that favoured a small range of hash indexes and led to reduced performance in large maps. Autofs now uses a "one-at-a-time" hash function which gives a better distribution of hash values in large hash tables. Use of the "one-at-a-time" hash function safeguards lookup performance as maps increase to 8,000 entries and beyond.
Comment 6 errata-xmlrpc 2009-09-02 07:59:45 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1397.html

Note You need to log in before you can comment on or make changes to this bug.